<?php
/*
Plesk Spamdyke Control Panel (Version see version.php) - GUI for Plesk spamdyke implementation

Copyright (C) [2008] [Matthias Hackbarth / www.haggybear.de]

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, see <http://www.gnu.org/licenses/>.
*/

/**
 * Klasse zum sammeln der Admin-Rechte Infos der Domain(s)
 */

class AdminRights{
     
     var $regKarten = "'dnsbl_settings','gl_settings','allg_settings','multi_right'";

     /** Variable, die die Domain aufnimmt */
     var $dieDomain;

     /** Variable, die alle Rechte aus der Rights.txt aufnimmt */
     var $alleRechte = array();

     var $glFolder;

     var $scriptFolder;

     var $isAllView = false;

     var $otherSettings = array("reject-empty-rdns","reject-missing-sender-mx","reject-unresolvable-rdns","reject-ip-in-cc-rdns");
     
     /**
       * Konstruktor
       *
       */

     function AdminRights($dom){

              $this->dieDomain = $dom;
              $this->scriptFolder = str_replace("index.php","",$_SERVER["SCRIPT_FILENAME"]);

	      $this->leseRechte();

             }
             
     function getDomainRight($recht){
     	
              $select = ($this->alleRechte[$this->dieDomain][$recht])?"selected":"";
	      
	      echo "<select name=\"$recht\">\n";
	      echo "<option value=\"0\">".VALUE_NO."</option>\n";
	      echo "<option value=\"1\" ".$select.">".VALUE_YES."</option>\n";
	      echo "</select>";
              }
              
     function getDomainRightMulti($dom,$recht){
     	
              $select = ($this->alleRechte[$dom][$recht])?"checked":"";
	      
	      $html = '<input type="checkbox" name="'.$dom.'#'.$recht.'" value="domrights" '.$select.'>'; 
	      return $html;
	      }

     function getEventHandler($typ){

              $res = mysql_query("SELECT id FROM event_handlers where command like '%plesk_event_handler.sh%' and command like '%".$typ."%'");
              $select = (mysql_num_rows($res)>0)?"selected":"";
	      
	      echo "<select name=\"$typ\">\n";
	      echo "<option value=\"0\">".VALUE_NO."</option>\n";
	      echo "<option value=\"1\" ".$select.">".VALUE_YES."</option>\n";
	      echo "</select>";
              }

     function setEventHandler($conf,$params){

              @mysql_query("DELETE FROM event_handlers where command like '%plesk_event_handler.sh%'");
              
              if($params["create"]) mysql_query("INSERT INTO event_handlers (action_id, priority, user, command )VALUES ( '21', '50', 'root', '".$this->scriptFolder."plesk_event_handler.sh create ".$conf["graylist-dir"]."/ <new_domain_name>')"); 
	      if($params["delete"]) mysql_query("INSERT INTO event_handlers (action_id, priority, user, command )VALUES ( '23', '50', 'root', '".$this->scriptFolder."plesk_event_handler.sh delete ".$conf["graylist-dir"]."/ <old_domain_name>')"); 
              if($params["update"]) mysql_query("INSERT INTO event_handlers (action_id, priority, user, command )VALUES ( '22', '50', 'root', '".$this->scriptFolder."plesk_event_handler.sh update ".$conf["graylist-dir"]."/ <old_domain_name> <new_domain_name>')"); 
              }

     function updateRechte($recht,$state){
              $this->alleRechte[$this->dieDomain][$recht] = $state;
	      }
	      
     function updateRechteMulti($data){
     	      $this->alleRechte = array();
     	      while (list($key, $val) = each($data)){
     	      	    if($val == "domrights"){
     	      	    	$handler = explode("#",$key);
     	      	    	$this->alleRechte[str_replace("_",".",$handler[0])][$handler[1]] = 1;
     	      	    	}
     	      	    }
     	      $this->schreibeRechte();
     	      }

     function schreibeRechte(){
              $write = serialize($this->alleRechte);
	      $openStream = fopen ("rights.txt","w");
	      fwrite($openStream,$write,strlen($write)); 
              fclose($openStream);
              }
              
     function leseRechte(){
     	      $file = fopen("rights.txt",'r');
	      $this->alleRechte = unserialize(trim(fread($file,filesize("rights.txt"))));
	      fclose($file);
              }

     function hideMe($width){
              if($this->isAllView) echo "<div id=\"blind\" style=\"width:$width\"></div>";
              }

     function setSpamDykeConf($conf,$post){

              $conf["graylist-level"] = $post["graylist-level"];
              if(!empty($post["graylist-min-secs"])){
              	 $conf["graylist-min-secs"] = $post["graylist-min-secs"];
              }else{
                 unset($conf["graylist-min-secs"]);
               }
              if(!empty($post["graylist-max-secs"])){
              	 $conf["graylist-max-secs"] = $post["graylist-max-secs"];
              }else{
                 unset($conf["graylist-max-secs"]);
               }
              if(!empty($post["greeting-delay-secs"])){
              	 $conf["greeting-delay-secs"] = $post["greeting-delay-secs"];
              }else{
                 unset($conf["greeting-delay-secs"]);
               }
              if(!empty($post["connection-timeout-secs"])){
              	 $conf["connection-timeout-secs"] = $post["connection-timeout-secs"];
              }else{
                 unset($conf["connection-timeout-secs"]);
               }
              if(!empty($post["idle-timeout-secs"])){
              	 $conf["idle-timeout-secs"] = $post["idle-timeout-secs"];
              }else{
                 unset($conf["idle-timeout-secs"]);
               }

              while (list($key, $val) = each($conf)){
                     if(!stristr($key,"dns-blacklist-entry") && !eregi("(".implode("|",$this->otherSettings).")",$key)){
                        $confNew[$key] = $val;
                        }
                     }
              $conf = $confNew;

              while (list($key, $val) = each($post["dns-blacklist-entry"])){
                     if(!empty($val)){
                        $key = ($post["dns-blacklist-entry-activ"][$key])?"dns-blacklist-entrySCP$key":"#dns-blacklist-entrySCP$key";
                        $conf[$key] = $val;
                        }
                     }

              while (list($key, $val) = each($post["conf-others"])){
                     if(!empty($val)){
                        $conf[$val] = "";
                        }
                     }  
           
              if(!empty($post["new_dnsbl"])){
                 $conf["dns-blacklist-entrySCPNEW"] = $post["new_dnsbl"];
                }
              

              while (list($key, $val) = each($conf)){
                $key = eregi_replace("SCP(.*)","",$key);
                $confFile.= (empty($val))?"$key\n":"$key=$val\n";
        	}

              #echo nl2br($confFile);
              exec('./wrapper "1" "writespamdykeconf '.SPAMDYKE_CONFIG.'" "'.$confFile.'"');

              }

      function getDnsblList($conf){

               $count = 1;
               while (list($key, $val) = each($conf)){
                      if(stristr($key,"dns-blacklist-entry")){
                         $checked = stristr($key,"#")?"":"checked";
                         echo "<tr>";
                         echo "<td>&nbsp;</td>";
                         echo "<td><input type=\"checkbox\" name=\"dns-blacklist-entry-activ[$count]\" value=\"1\" $checked></td>";
                         echo "<td><input type=\"text\" size=\"50\" name=\"dns-blacklist-entry[$count]\" value=\"$val\"></td>";
                         echo "</tr>";
                         $count++;
                         }
                      }
               


               }

      function getOtherSettings($conf){

               $count = 1;
               while (list($key, $val) = each($conf)){
                      $found = array_search(trim(str_replace("#","",$key)),$this->otherSettings);
                      if($found > -1){
                         $checked = stristr($key,"#")?"":"checked";
                         echo "<tr>";
                         echo "<td>&nbsp;</td>";
                         echo "<td><input type=\"checkbox\" name=\"conf-others[$count]\" value=\"$key\" $checked></td>";
                         echo "<td>".constant("SCP_ALLG_SPAMDYKE_OTHER_".strtoupper(str_replace("#","",$key)))."</td>";
                         echo "</tr>";
                         $count++;
                         unset($this->otherSettings[$found]);
                         }
                      }
               sort($this->otherSettings);
               for($r=0;$r<count($this->otherSettings);$r++){
                   echo "<tr>";
                   echo "<td>&nbsp;</td>";
                   echo "<td><input type=\"checkbox\" name=\"conf-others[$count]\" value=\"".$this->otherSettings[$r]."\"></td>";
                   echo "<td>".constant("SCP_ALLG_SPAMDYKE_OTHER_".strtoupper($this->otherSettings[$r]))."</td>";
                   echo "</tr>";
                   $count++;
                   }

               }
               
      function viewAdmPart($part){
      	       echo '<script type="text/javascript">';
      	       if(!empty($part)){
      	       	  echo 'adminView(\''.$part.'\');';
      	       	  }
      	       echo 'ermittlePids();';
	       echo '</script>';
      	       }
      	
      function actSpamdykeProc($kill=false){
      	
      	       if($kill){
      	          exec('./wrapper "1" "killallspamdyke"');
      	       }else{      	        
      	          exec('ps -ef | grep spamdyke', $out); 
      	          echo count($out);
      	          }
      	       }

     function getSpamdykeVer(){
              exec('./wrapper "1" "spamdykeversion"',$out);
              echo $out[0];
              }
      	       
     function viewAllDomains(){
     	      $tmpDom = $this->dieDomain;
     	      $res = mysql_query("SELECT name FROM psa.domains");
     	      $c = 0;
     	      while($data = mysql_fetch_object($res)){
     	      	   $farbe = ($c%2)?"bgcolor='#CCCCCC'":"";
     	      	   echo '<tr '.$farbe .'>';
     	      	   echo '<td>'.$data->name.'</td>';
     	      	   echo '<td colspan="2">'.$this->getDomainRightMulti($data->name,'gl').'</td>';
     	      	   echo '<td colspan="2">'.$this->getDomainRightMulti($data->name,'ip').'</td>';
     	      	   echo '<td colspan="2">'.$this->getDomainRightMulti($data->name,'sender').'</td>';
     	      	   echo '<td colspan="2">'.$this->getDomainRightMulti($data->name,'recipient').'</td>';
     	      	   echo '<td colspan="2">'.$this->getDomainRightMulti($data->name,'rdns').'</td>';
     	      	   echo '<td colspan="2">'.$this->getDomainRightMulti($data->name,'keywords').'</td>';
     	      	   $c++;
     	      	   }
     	      }

     }













?>